#include <pybind11/pybind11.h>
#include <pybind11/stl.h>
#include <pybind11/functional.h>


namespace py = pybind11;

void py_init_module_imgui_bundle_inner(py::module& m);
void py_init_module_hello_imgui(py::module& m);
void py_init_module_imgui_main(py::module& m);
void py_init_module_imgui_internal(py::module& m);
void py_init_module_implot(py::module& m);
void py_init_module_imgui_color_text_edit(py::module& m);
void py_init_module_imgui_node_editor(py::module& m);
void py_init_module_imgui_knobs(py::module& m);
void py_init_module_im_file_dialog(py::module& m);
void py_init_module_imspinner(py::module& m);
void py_init_module_imgui_md(py::module& m);


void py_init_module_imgui_bundle(py::module& m)
{
    py_init_module_imgui_bundle_inner(m);

    auto module_imgui =  m.def_submodule("imgui");
    py_init_module_imgui_main(module_imgui);

    auto module_imgui_internal =  m.def_submodule("imgui_internal");
    py_init_module_imgui_internal(module_imgui_internal);

    auto module_himgui =  m.def_submodule("hello_imgui");
    py_init_module_hello_imgui(module_himgui);

    auto module_implot =  m.def_submodule("implot");
    py_init_module_implot(module_implot);

    auto module_imgui_color_text_edit =  m.def_submodule("imgui_color_text_edit");
    py_init_module_imgui_color_text_edit(module_imgui_color_text_edit);

    auto module_imgui_node_editor =  m.def_submodule("imgui_node_editor");
    py_init_module_imgui_node_editor(module_imgui_node_editor);

    auto module_imgui_knobs =  m.def_submodule("imgui_knobs");
    py_init_module_imgui_knobs(module_imgui_knobs);

	auto module_im_file_dialog =  m.def_submodule("im_file_dialog");
	py_init_module_im_file_dialog(module_im_file_dialog);

    auto module_imspinner =  m.def_submodule("imspinner");
    py_init_module_imspinner(module_imspinner);

    auto module_imgui_md =  m.def_submodule("imgui_md");
    py_init_module_imgui_md(module_imgui_md);
}


// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// <litgen_glue_code>  // Autogenerated code below! Do not edit!

// </litgen_glue_code> // Autogenerated code end
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE END !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


#include "hello_imgui/hello_imgui.h"
#include "imgui_bundle/imgui_bundle.h"
#include "imgui-node-editor/imgui_node_editor_internal.h"


namespace ax
{
    namespace NodeEditor
    {
        // using EditorContext = Detail::EditorContext;
        struct EditorContext: public Detail::EditorContext {};
    }
}


void py_init_module_imgui_bundle_inner(py::module& m)
{
    using namespace ImGuiBundle;
    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    // <litgen_pydef> // Autogenerated code below! Do not edit!
    ////////////////////    <generated_from:imgui_bundle.h>    ////////////////////
    m.def("run",
        py::overload_cast<HelloImGui::RunnerParams &, bool, bool, const std::optional<NodeEditorConfig> &, bool, const std::optional<ImGuiMd::MarkdownOptions> &>(ImGuiBundle::Run),
        py::arg("runner_params"), py::arg("with_implot") = false, py::arg("with_node_editor") = false, py::arg("with_node_editor_config") = py::none(), py::arg("with_markdown") = false, py::arg("with_markdown_options") = py::none(),
        "Helper to run a hello_imgui app for imgui_bundle:\n\n- if `with_markdown` or `with_markdown_options` is specified, then  the markdown context will be initialized\n    (i.e. required fonts will be loaded)\n- if `with_implot` is True, then a context for implot will be created/destroyed automatically\n- if `with_node_editor` or with_node_editor_config` is specified, then a context for imgui_node_editor\n    will be created automatically.");

    m.def("run",
        py::overload_cast<const HelloImGui::VoidFunction &, const std::optional<ImVec2> &, const std::optional<std::string> &, bool, bool, const std::optional<NodeEditorConfig> &, bool, const std::optional<ImGuiMd::MarkdownOptions> &>(ImGuiBundle::Run),
        py::arg("gui_function"), py::arg("window_size") = py::none(), py::arg("window_title") = py::none(), py::arg("with_implot") = false, py::arg("with_node_editor") = false, py::arg("with_node_editor_config") = py::none(), py::arg("with_markdown") = false, py::arg("with_markdown_options") = py::none(),
        "Helper to run a hello_imgui app for imgui_bundle:\n\n- if `with_markdown` or `with_markdown_options` is specified, then  the markdown context will be initialized\n    (i.e. required fonts will be loaded)\n- if `with_implot` is True, then a context for implot will be created/destroyed automatically\n- if `with_node_editor` or with_node_editor_config` is specified, then a context for imgui_node_editor\n    will be created automatically.");

    m.def("now",
        ImGuiBundle::Now);

    m.def("current_node_editor_context",
        ImGuiBundle::CurrentNodeEditorContext);
    ////////////////////    </generated_from:imgui_bundle.h>    ////////////////////

    // </litgen_pydef> // Autogenerated code end
    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  AUTOGENERATED CODE END !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
}
